// : Alex Defsen
//    GNU

// Dims -     :3

unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OverbyteIcsWndControl, OverbyteIcsWSocket, ComCtrls,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, Menus,
  JvExStdCtrls, JvRichEdit;

type
  TMainForm = class(TForm)
    Socket: TWSocket;
    Log: TMemo;
    Button1: TButton;
    Button2: TButton;
    VCode: TEdit;
    Chat: TJvRichEdit;
    Cmd: TEdit;
    Msg: TEdit;
    Actions: TListBox;
    Button3: TButton;
    UserList: TListView;
    Button4: TButton;
    Button5: TButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SocketDataAvailable(Sender: TObject; ErrCode: Word);
    procedure CmdKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ChatChange(Sender: TObject);
    procedure MsgKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure UserList1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ActionsDblClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
  private
    procedure Send(Str: String); //         
    procedure ParseLine(Str: String); //     
    procedure ParseUsers(Str: String; JOIN: Boolean = False);
    function GetUserItem(ID: String) : TListItem;
    procedure AddUser(ID, Nick, Clan, Pos: String);
    procedure GetMyNick;
    procedure AddFormatText(Text: String; Format: Integer = 0);
    function ClearTags(Str: String): String;
    procedure ParseAuthority(Str: String);
  public

  end;

var
  MainForm: TMainForm;

  MyID, MyNick, MyPasswd: String;

  R: Boolean = False;

implementation

{$R *.dfm}

procedure TMainForm.ActionsDblClick(Sender: TObject);
begin                                   
  if Actions.ItemIndex <> -1 then
    Send('JOIN ' + copy(Actions.Items[Actions.ItemIndex], 1, pos(' ', Actions.Items[Actions.ItemIndex])-1));
end;

procedure TMainForm.AddFormatText(Text: String; Format: Integer = 0);
var
  Font: TFont;
begin
  Font := TFont.Create;

  case Format of
    0: Font.Color := clWhite; //  

    1: Begin //   
       Font.Color := clRed;
       Font.Style := [fsBold];
       End;

    2: Font.Color := clSilver; //  

    3: Begin //   
       Font.Color := clSilver;
       Font.Style := [fsBold];
       End;

    4: Font.Color := $000080FF; // /

    5: Font.Color := clRed; //   

    6: Begin //  
       Font.Color := clWhite;
       Font.Style := [fsBold];
       End;

    7: Begin // 
       Font.Color := clYellow;
       Font.Style := [fsBold];
       End;
  end;

  Chat.AddFormatText(Text + #13#10, Font);
  Font.Free;
end;

procedure TMainForm.AddUser(ID, Nick, Clan, Pos: String);
begin
  with UserList.Items.Add do
    Begin
    Caption := ID;
    SubItems.Add(Nick);
    SubItems.Add(Clan);
    SubItems.Add(Pos);
    SubItems.Add('');
    End;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if Socket.State <> wsClosed then //   ,    
    exit;                          //     

  Socket.Addr := 'galaxy.mobstudio.ru';
  Socket.Port := '6667';
  //    

  Socket.LineMode := True; //    
  Socket.LineEnd := #13#10; //  

  Socket.Connect;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  if Socket.State = wsClosed then 
    exit;

  Send('QUIT :ds'); //     
  Socket.Close; // 
end;

procedure TMainForm.Button3Click(Sender: TObject);
var
  HTTP: TIdHTTP;
  R: String;
begin
//services/index.php?a=channel_lists_popular&userID=7321635&password=3g6o1eq2&kbv=92&lngg=ru&dbl=2

  Http := TIdHTTP.Create(MainForm);

  try
    R := Utf8Decode(Http.Get('http://galaxy.mobstudio.ru/services/index.php?a=channel_lists_popular&userID=' + MyID + '&password=' + MyPasswd + '&kbv=92&lngg=ru&dbl=2'));

  finally
    Http.Free;
  end;

  Actions.Items.Text := ClearTags(R);

end;

procedure TMainForm.Button4Click(Sender: TObject);
var
  I, Cnt: Integer;
begin
  Cnt := UserList.Items.Count - 1;
  for I := 0 to Cnt do
    Send('BAN ' + UserList.Items[i].Caption);
end;

procedure TMainForm.Button5Click(Sender: TObject);
var
  I, Cnt: Integer;
begin
  Cnt := UserList.Items.Count - 1;
  for I := 0 to Cnt do
    Send('KICK ' + UserList.Items[i].Caption);
end;

procedure TMainForm.ChatChange(Sender: TObject);
begin
  Chat.Perform(EM_SCROLL, SB_PAGEDOWN, 1);
end;

function TMainForm.ClearTags(Str: String): String;
var
  Len, WLen, RPos, OPos, WPos: integer;
begin
  Len := Length(Str);

  if Len = 0 then
    Exit;

  SetLength(Result, Len);

  RPos := 1;
  WPos := 1;

  while RPos < Len do
  begin
    OPos := RPos;

    while (Str[RPos] <> Char('<')) and (RPos < Len) do
      Inc(RPos);

    WLen := RPos - OPos;

    if WLen > 0 then
    begin
      Move(Str[OPos], Result[WPos], WLen*2);
      Inc(WPos, WLen);
    end;

    while (Str[RPos] <> Char('>')) and (RPos < Len) do
      Inc(RPos);

    Inc(RPos);
  end;

  SetLength(Result, WPos - 1);

  // 
  Delete(Result, 1, 21);
  Result := StringReplace(Result, '  ', #13#10, [rfReplaceAll]);
  Delete(Result, pos('', Result), 17);
end;

procedure TMainForm.CmdKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_Return then
    Begin
    Send(Trim(Cmd.Text));
    Cmd.Clear;
    End;
end;

procedure TMainForm.GetMyNick;
var
  it: TListItem;
begin
  It := GetUserItem(MyID);

  if It <> nil then
    MyNick := It.SubItems[0];
end;

function TMainForm.GetUserItem(ID: String): TListItem;
var
  I, Count: Integer;
begin
  Result := nil;
  Count := UserList.Items.Count - 1;

  for I := 0 to Count do
    if UserList.Items[i].Caption = ID then
      Begin
      Result := UserList.Items[i];
      Break;
      End;       
end;

procedure TMainForm.MsgKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_Return then
    Begin
    Send('PRIVMSG 0 :' + Msg.Text);
    AddFormatText(': ' + Msg.Text, 6);
    Msg.Clear;
    End;
end;

procedure TMainForm.N1Click(Sender: TObject);
begin
  if UserList.Selected = nil then
    exit;

  Send('KICK ' + UserList.Selected.Caption);
end;

procedure TMainForm.N2Click(Sender: TObject);
begin
  if UserList.Selected = nil then
    exit;

  Send('BAN ' + UserList.Selected.Caption);
end;

procedure TMainForm.ParseAuthority(Str: String);
var
  A, B: String;
begin
  Delete(Str, 1, 4);
  Str := Str + ' ';

  while Length(Str) > 1 do
    Begin
    A := copy(Str, 1, pos(' ', Str)-1);
    Delete(Str, 1, pos(' ', Str));
    B := copy(Str, 1, pos(' ', Str)-1);
    Delete(Str, 1, pos(' ', Str));

    GetUserItem(A).SubItems[3] := B;
    End;
end;

procedure TMainForm.ParseLine(Str: String);
var
  Data: TStringList; //   
begin
  if Str = '' then
    exit;

  Log.Lines.Add('<' + Str); //     

  Data := TStringList.Create; //  
  Data.Delimiter := ' '; //    << 
  Data.DelimitedText := Str; //  ,     

  try

    if Data[0] = 'HAAAPSI' then
      Begin
      Send(':ru IDENT 34 -1 4030 :GALA');
      Send('RECOVER ' + Trim(VCode.Text)); // Trim        
      End

    else

    if Data[0] = 'REGISTER' then
      Begin
      MyID := Data[1];
      MyPasswd := Data[2];
      Send('USER ' + copy(Str, pos(' ', Str)+1, Length(Str)));
      End

    else

    if Data[0] = '999' then
      Begin
      Send('ADDONS');
      Send('MYADDONS');
      Send('JOIN');
      End

    else

    if Data[0] = 'PING' then
      Begin
      Send('PONG');
      End

    else

    if Data[0] = '353' then
      Begin
      ParseUsers(copy(Str, pos(':', Str)+1, Length(Str)), False);
      End

    else

    if Data[0] = 'JOIN' then
      Begin
      ParseUsers(copy(Str, pos(' ', Str)+1, Length(Str)), True);
      End

    else

    if (Data[0] = 'SLEEP') or (Data[0] = 'PART') then
      Begin
      AddFormatText(' ' + GetUserItem(Data[1]).SubItems[0] + '  ', 4);
      GetUserItem(Data[1]).Delete;
      End

    else

    if Data[0] = 'PRIVMSG' then
      Begin
      if pos(MyNick, Str) <> 0 then
        AddFormatText(GetUserItem(Data[1]).SubItems[0] + ': ' + copy(Str, pos(':', Str)+1, Length(Str)), 1)
      else
        AddFormatText(GetUserItem(Data[1]).SubItems[0] + ': ' + copy(Str, pos(':', Str)+1, Length(Str)));
      End

    else

    if Data[0] = '366' then
      Begin
      GetMyNick;
      End

    else 

    if (Data[0] = '451') or (Data[0] = '431') then
      Begin
      AddFormatText(copy(Str, pos(':', Str)+1, Length(Str)), 5);
      R := False;
      End

    else

    if Data[0] = 'ACTION' then
      Begin
      if pos(MyNick, Str) <> 0 then
        AddFormatText(copy(Str, pos(':', Str)+1, Length(Str)), 3)
      else
        AddFormatText(copy(Str, pos(':', Str)+1, Length(Str)), 2);
      End

    else

    if Data[0] = '332' then
      Begin
      AddFormatText(copy(Str, pos(':', Str)+1, Length(Str)), 7);
      End

    else

    if Data[0] = '860' then
      Begin
      ParseAuthority(Str);
      End

    else

    if Data[0] = '853' then
      Begin
      R := True;
      End;
    


  finally
    Data.Free; //   !!!!!!!11111111
  end;
end;

procedure TMainForm.ParseUsers(Str: String; JOIN: Boolean);
var
  uNick, uClan, uID, uPos, uHead, uBody: String;
begin
  if R = True then
    Begin
    Chat.Clear;
    UserList.Clear;
    R := False;
    End;

  Str := Str + ' ';

  while Length(Str) >= 1 do
    Begin
    uClan := copy(Str, 1, pos(' ', Str)-1);
    Delete(Str, 1, pos(' ', Str));

    uNick := copy(Str, 1, pos(' ', Str)-1);
    Delete(Str, 1, pos(' ', Str));

    uID := copy(Str, 1, pos(' ', Str)-1);
    Delete(Str, 1, pos(' ', Str));

    uHead := copy(Str, 1, pos(' ', Str)-1);
    Delete(Str, 1, pos(' ', Str));

    if uHead = '-1' then
      Begin
      Delete(Str, 1, pos(' ', Str));
      Delete(Str, 1, pos(' ', Str));
      Delete(Str, 1, pos(' ', Str));
      Delete(Str, 1, pos(' ', Str));
      End;

    uBody := copy(Str, 1, pos(' ', Str)-1);
    Delete(Str, 1, pos(' ', Str));

    uPos := copy(Str, 1, pos(' ', Str)-1);
    Delete(Str, 1, pos(' ', Str));

    if uNick[1] = '+' then
      Begin
      Delete(uNick, 1, 1);

      //
      End;

    if uNick[1] = '@' then
      Begin
      Delete(uNick, 1, 1);

      //
      End;

    if GetUserItem(uID) <> Nil then
      Exit;

    AddUser(uID, uNick, uClan, uPos);

    if JOIN then
      Begin
      AddFormatText(' ' + uNick + '   ', 4);
      exit;
      End;
  End;
end;

procedure TMainForm.Send(Str: String);
begin
  if Socket.State <> wsConnected then //            
    exit;

  Socket.SendStr(Utf8Encode(Str) + #13#10);
  Log.Lines.Add('>' + Str); //   
end;

procedure TMainForm.SocketDataAvailable(Sender: TObject; ErrCode: Word);
var
  S: String;
begin
  S := Trim(Utf8Decode(Socket.ReceiveStr));
  ParseLine(S); //   
end;

procedure TMainForm.UserList1Click(Sender: TObject);
begin
  if UserList.Selected = nil then
    exit;

  Msg.Text := UserList.Selected.SubItems[0] + ', ';
end;

end.
